# Perceptron Linear Classifier
# Dr. Fred Park
# Whittier College, Fall 2017, COSC 120

####################
# load training data
import matplotlib.pyplot as plt # matplotlib = python plotting library
import matplotlib.image as mpimg # image viewing
import numpy as np
from copy import deepcopy
import sys
import time
from random import random as rd


Ltrain = []
nameHandle1 = open('exam_scores_training.txt','r')
#file handle called nameHandle, 'a': append

for line in nameHandle1:
  #print(line.split()) #debugging
  Ltrain.append(line.split())
nameHandle1.close()

Ntrain = len(Ltrain)


x1 = np.zeros((Ntrain), dtype=float)
x2 = np.zeros((Ntrain), dtype=float)
y = np.zeros((Ntrain), dtype=float)

for i in range(Ntrain):
  x1[i] = Ltrain[i][0]
  x2[i] = Ltrain[i][1]
  y[i] = Ltrain[i][2]


N = Ntrain
area = 25

xp1 = []; xnp1 = [];
xp2 = []; xnp2 = [];

for i in range(Ntrain):
  if y[i] == 1:
    xp1.append(x1[i])
    xp2.append(x2[i])
  else:
    xnp1.append(x1[i])
    xnp2.append(x2[i])

print('process starting in 2 secs... be patient :)')
plt.ion()
groups = ("did not pass", "passed")
pss =  plt.scatter(xp1, xp2, s=area, c="blue", alpha=1.0, label='pass')
npss = plt.scatter(xnp1, xnp2, s=area, c="red", alpha=1.0, label='no pass')
plt.legend(loc=4)
plt.title('Exam Pass/No Pass data')
plt.xlabel('exam 1')
plt.ylabel('exam 2')
plt.axis([0, 100, 0, 100])
#plt.show()
plt.pause(2)



#sigmoid function
def g(z):
  return 1/(1+np.exp(-z))

#predictior function
def h(t1,t2,x1,x2,b):
  return g(t1*x1 + t2*x2 + b)

#line function
def L(t1,t2,b,X):
  return -(1/t2)*(t1*X + b)


# random permutation of data indices
r = np.random.permutation(100)

#initial valaues of theta and b
#t1 = rd(); t2 = rd(); b = rd(); # random guess
t1 = -0.001; t2 = 1.5; b = -60

t = np.array([t1,t2])
alpha = 5e-4 # learning rate
N_its = 700 #number of outer iterations
print('init params =',t1,t2,b)
groups = ("did not pass", "passed")
X = np.arange(0,101);
N = Ntrain
area = 25
xp1 = []; xnp1 = [];
xp2 = []; xnp2 = [];

for i in range(Ntrain):
  if y[i] == 1:
    xp1.append(x1[i])
    xp2.append(x2[i])
  else:
    xnp1.append(x1[i])
    xnp2.append(x2[i])

#main iteration
for j in range(N_its):
  r = np.random.permutation(100)
  for ri in r:
    x = np.array([x1[ri], x2[ri]])
    h2 = np.dot(t,x) + b
    t1 = t1 - alpha*( (g(h2)-y[ri])*g(h2)*(1-g(h2))*x1[ri] )
    t2 = t2 - alpha*( (g(h2)-y[ri])*g(h2)*(1-g(h2))*x2[ri])
    b = b - alpha*( (g(h2)-y[ri])*g(h2)*(1-g(h2))*1)
    t[0] = t1; t[1] = t2;
  if j%10 == 0:
    print('theta1 = %3.3f, theta2 = %3.3f, b = %3.3f, (iteration #%d)' %(t1, t2, b,j))
    plt.ion() #interactive plotting mode on
    plt.axis([0, 100, 0, 100])
    pss = plt.scatter(xp1, xp2, s=area, c="blue", alpha=1.0, label='pass')
    npss = plt.scatter(xnp1, xnp2, s=area, c="red", alpha=1.0, label='no pass')
    plt.plot(X, L(t1, t2, b, X), c="green")
    plt.legend(loc=4)
    plt.title('Exam Pass/No Pass data')
    plt.xlabel('exam 1')
    plt.ylabel('exam 2')
    #plt.show()
    plt.pause(0.25)
    plt.clf()

print('****************************************************************')
print('***  Main Iteration Finished! Figure will close in 30 secs!  ***')
print('** Final Params: theta1 = %3.3f, theta2 = %3.3f, b = %3.3f. **' % (t1, t2, b))
print('****************************************************************')

plt.ion()
plt.ion()
plt.axis([0, 100, 0, 100])
pss = plt.scatter(xp1, xp2, s=area, c="blue", alpha=1.0, label='pass')
npss = plt.scatter(xnp1, xnp2, s=area, c="red", alpha=1.0, label='no pass')
plt.plot(X, L(t1, t2, b, X), c="green")
plt.legend(loc=4)
plt.title('Exam Pass/No Pass data')
plt.xlabel('exam 1')
plt.ylabel('exam 2')
#plt.show()
plt.pause(30) #close after 10 seconds




# ## testing data
# Ltest = []
# nameHandle2 = open('exam_scores_testing.txt','r') #file handle called nameHandle, 'a': append
# for line in nameHandle2:
#   Ltest.append(line.split(","))
# nameHandle2.close()
#
# Ntest = len(Ltest)
#
# for i in range(Ntest):
#   print(Ltest[i])
#
# x1t = np.zeros((Ntest), dtype = float);  x2t = np.zeros((Ntest), dtype = float);
# yt = np.zeros((Ntest), dtype = float);
#
# for i in range(Ntest):
#   x1t[i] = Ltest[i][0]
#   x2t[i] = Ltest[i][1]
#   yt[i] = Ltest[i][2]
#
# print(x1t)
# print(x2t)
# print(yt)
